#include "StdAfx.h"
#include ".\outfile.h"

OutFile::OutFile(char *filename, int numberOfLines, int numberOfColumns)
: m_saveFile(NULL)
{
	m_numberOfLines = numberOfLines + 1;
	m_numberOfColumns = numberOfColumns + 2;
	m_numberOfCharsPerWord = 100;
	
	////////m_wordArray/////////////////////
	m_wordArray = new char**[m_numberOfLines]; // lines
	for (int i=0; i < m_numberOfLines; i++)
	{
		m_wordArray[i] = new char*[m_numberOfColumns]; // columns
	}

	for (int i=0; i < m_numberOfLines; i++)
	{
		for (int j=0; j < m_numberOfColumns; j++)
		{
			m_wordArray[i][j] = new char[m_numberOfCharsPerWord]; // characters per word
		}
	}

	/////////////m_saveFile///////////////////////////
	m_saveFile = fopen (filename, "w");
}

OutFile::~OutFile(void)
{
	////////m_wordArray/////////////////////
	for (int i=0; i < m_numberOfLines; i++)
	{
		for (int j=0; j < m_numberOfColumns; j++)
		{
			delete[] m_wordArray[i][j]; // erases the words
		}
	}

	for (int i=0; i < m_numberOfLines; i++)
	{
		delete[] m_wordArray[i]; // erases the columns
	}

	delete[] m_wordArray; // erases the array as a whole

	/////////////m_saveFile///////////////////////////
	fclose (m_saveFile);
}

void OutFile::showWordArray(void)
{
	printf("\n\n");
	for (int line = 0; line < m_numberOfLines; line++)
	{
		int i=0;
		while ( strcmp( m_wordArray[line][i], "|||") != 0 )
		{
			printf(m_wordArray[line][i]); printf(" ");
			i++;
		}
		printf("\n");
	}
}

void OutFile::getWord(char* word, int lineNumber, int columnNumber)
{
	strcpy( m_wordArray[lineNumber][columnNumber], word );
	if ((lineNumber+1) > m_numberOfLines)
		m_numberOfLines = lineNumber+1;
}

void OutFile::SaveToFile()
{
	for (int line = 0; line < m_numberOfLines; line++)
	{
		int i=0;
		while ( strcmp( m_wordArray[line][i], "|||") != 0 )
		{
			fprintf(m_saveFile, m_wordArray[line][i]); fprintf(m_saveFile, "\t");
			i++;
		}
		fprintf(m_saveFile, "\n");
	}
}
